//Copyright (c) 2007 Susan Fairley.
//19k3 
//empty table used to store mismatch codes
truncate table GeneratedVariants
go
//empty table used to store results
truncate table Mismatches
go
declare
//select probes to be mapped into cursor.
//in this case all from table Expprobes
cursor probe_codes
is
    select *
    from Expprobes;
code_list revcode_varray_fromcode;
begin
//for each probe generate its matches and record them in generated variants.
for probe_rec in probe_codes
loop
code_list := generateRevMismatchesFromCode(probe_rec.code);
forall i in (code_list.FIRST + 1) .. (code_list(1)/2)
insert into GENERATEDVARIANTS(Code, Probeset, IP, Orientation) values(code_list(i), probe_rec.Probeset, probe_rec.IP, 'F');
forall i in (code_list(1)/2)+1 .. code_list(1)
insert into GENERATEDVARIANTS(Code, Probeset, IP, Orientation) values(code_list(i), probe_rec.Probeset, probe_rec.IP, 'R');
end loop;
//join GeneratedVariants and Sequoia, placing results in mismatches
insert into Mismatches(Probeset, IP,CHROMOSOME, LOCATION, Orientation)
select/*+ordered INDEX(Sequoia)*/ Probeset, IP, Chromosome, LOCATION, Orientation
from GeneratedVariants, Sequoia
where GeneratedVariants.Code = Sequoia.CODE;
execute immediate 'truncate table GENERATEDVARIANTS';
commit;
end;