//Copyright (c) 2007 Susan Fairley.
//19k1
//empty table used to store possible matches
truncate table GeneratedVariants
go
//empty table used to store results
truncate table Onemismatch
go
declare
//select probes into cursor
cursor probe_codes
is
    select *
    from Expprobes;
code_list one_mismatch_code_varray;
begin
//for all probes generate mismatches and store in generated variants
for probe_rec in probe_codes
loop
code_list := generateRevOneMismatchCode(probe_rec.code);
forall i in (code_list.FIRST + 1) .. (code_list(1)/2)
insert into GENERATEDVARIANTS(Code, Probeset, IP, Orientation) values(code_list(i), probe_rec.Probeset, probe_rec.IP, 'F');
forall i in (code_list(1)/2)+1 .. code_list(1)
insert into GENERATEDVARIANTS(Code, Probeset, IP, Orientation) values(code_list(i), probe_rec.Probeset, probe_rec.IP, 'R');
end loop;
//join GeneratedVariants and Sequoia and store in Onemismatch
insert into Onemismatch(Probeset, IP,CHROMOSOME, LOCATION,Orientation)
select/*+ordered INDEX(Sequoia)*/ Probeset, IP, Chromosome, LOCATION, Orientation
from GeneratedVariants, Sequoia
where GeneratedVariants.Code = Sequoia.CODE;
execute immediate 'truncate table GENERATEDVARIANTS';
commit;
end;