//Copyright (c) 2007 Susan Fairley.
//any 16ex
//empty table to store mismatches
truncate table GeneratedVariants
go
//empty results table
truncate table Sixteen
go
declare
//select probes for matching into cursor
cursor probe_seqs
is
    select *
    from Expprobes;
code_ranges sixteen_code_varray;
begin
//for each probe generate the possible matches and store in GeneratedVariants
for probe_rec in probe_seqs
loop
code_ranges := exactAndRevSixteen(probe_rec.Seq);
//store forward matches
for i in (1) .. (10)
loop
insert into GENERATEDVARIANTS(Code, Probeset, IP, Orientation, Probeposition) values(code_ranges(i), probe_rec.Probeset, probe_rec.IP, 'F', i);
end loop;
//store reverse matches
for i in (11) .. (20)
loop
insert into GENERATEDVARIANTS(Code, Probeset, IP, Orientation, Probeposition) values(code_ranges(i), probe_rec.Probeset, probe_rec.IP, 'R', (i-10));
end loop;
end loop;
commit;
//select all codes in matching ranges from sequoia and store results in Sixteen
insert into Sixteen(Chromosome, Location, Probeset, IP, Orientation, Probeposition)
select/*+ordered INDEX(Sequoia)*/ Sequoia.CHROMOSOME, Sequoia.Location, GeneratedVariants.PROBESET, GeneratedVariants.IP, GeneratedVariants.ORIENTATION, GeneratedVariants.PROBEPOSITION
from GeneratedVariants, Sequoia
where Sequoia.Code between GeneratedVariants.Code and (GeneratedVariants.Code +124);
execute immediate 'truncate table GENERATEDVARIANTS';
commit;
end;